/************************************************************************************************
 **  PROGRAM - Dragons and Treasure 1.0                     *  AUTHOR: Jerry Baldwin            **
 **  Started - 10/12/13                                     *                                   **
 **  Finished -                                             **************************************
 **  Last Edit Date & Time - 05-Jul-2017 at 21:00                                               **
 **  Purpose - Simple find treasure game.  Using program to learn                               **
 **            various techniques for a future designs.                                         **
 **  Files include - DNT.dat                                                                    **
 **  C++ Files include - main.cpp, title.cpp, play.cpp, allegro.cpp, rand.cpp , board.cpp       **
 **                      keys.cpp, sound.cpp, target.cpp, map.cpp                               **
 **  Games Specific Include Files: allcolor.h, d_array.h, Dragons.h                             **
 *************************************************************************************************/
#define ALLEGRO_STATICLINK
#include <allegro.h>
#include <iostream>
#include <string>
#include <cstdio>
#include <d_array.h>
#include <Dragons.h>
#include <fstream>
using namespace std;


int a_init();
int menu(BITMAP *[],DATAFILE*);
void instruct(BITMAP *[], DATAFILE*);
void credits(BITMAP *[], DATAFILE*);
void gameplay(BITMAP *[],bchar [] ,char[][15], char[][15],int,DATAFILE *);
void board_init(char[][15],char[][15], BITMAP *[],bchar [], int,DATAFILE *);

int main(int argc, char *argv[]) {
/************Setup / Configurations ***********/
	bchar token[4];            // Array for board pieces
	BITMAP *GameBitmaps[3];    //BITMAPs for Game graphics
	DATAFILE *GameDat = NULL;  // DAT file with all screen - Fonts - Sounds
	char resp = ' ';           // Initializing Key Response
    char board[15][15];        // Playing Board
    char walls[15][15];        // Allows walls to stay hidden until ran into
    int sound_clip = 69;       // Random Number Init
    a_init();                  // Set Up Allegro


	GameDat = load_datafile("Dragons.dat");                // Load Data file and create bitmaps
	GameBitmaps[BUFFER]= create_bitmap(640,480);
	GameBitmaps[BUF_HOLD]= create_bitmap(640,480);
	GameBitmaps[2]= create_bitmap(640,480);

/*********** Start Program ****************/
    while(resp != KEY_Q){
    	resp = menu(GameBitmaps,GameDat); // Menu Screen, Get User Choice
        if (resp == KEY_I){                      // Game Instruction Screen
	        instruct(GameBitmaps,GameDat);
	        resp = ' ';
          } // End Instructions IF 
        if (resp == KEY_C){                      //Credits Screen
            credits(GameBitmaps,GameDat);
            resp = ' ';            
          } // End Credits IF 
        if (resp == KEY_P){                         // Game Play Start
	        board_init(board, walls,GameBitmaps, token,sound_clip,GameDat);  // Set up player's position and empty spaces.
	        gameplay(GameBitmaps,token,board,walls,sound_clip,GameDat); 
	        resp = ' ';
          } // End Gameplay IF 

     clear_to_color(GameBitmaps[BUF_HOLD],makecol(0, 0, 0));     //Black out Screen Buffers
	 clear_to_color(GameBitmaps[BUFFER],makecol(0, 0, 0));

} // While Quit loop

	return EXIT_SUCCESS;

} // End of main();

END_OF_MAIN();
