/*************************************************************************************************
 **  PROGRAM - Dragons and Treasure                         *  AUTHOR: Jerry Baldwin            **
 **  Started - 11/30/13                                     *                                   **
 **  Finished - 07/05/2017                                  **************************************
 **  Last Edit Date & Time - 21:00  07/05/2017                                                  **
 **  Purpose - D&T game play  - Updates board data based on player move                         **
 *************************************************************************************************/
#include <allegro.h>
#include <iostream>
#include <string>
#include <cstdio>
#include <allcolor.h>
#include <d_array.h>
#include <fstream>
#include <Dragons.h>
#define OFFSET 2  // Offset to allow for wall between playing squares

using namespace std;

char Player(char[][15],char[][15],bchar [],int,DATAFILE *,int);
void Dragon(char[][15],bchar [],DATAFILE *,int);
int dir_key();
void draw_board(char[][15],BITMAP *[],bchar [],DATAFILE*);
char check_collision(bchar []);
char check_close(bchar []);
void Win_Lose(char,DATAFILE *,int);
void game_sounds(DATAFILE *,int);

void gameplay(BITMAP *GameBitmaps[],bchar token[],char board[][15], char walls[][15],int sound_clip,DATAFILE *GameDat){

	    char status = '*';
	    char contact = '*';
        bool Close_Status = FALSE;
        bool Treasure_Captured = FALSE;

        int loop = 6;
        int count = 0;    

	while(TRUE){

	    draw_board(board,GameBitmaps,token,GameDat);
	    clear_keybuf();

	    if(token[PLAYER].piece == 'C') // Drops from 6 to 4 square move once treasure is Captured
	      loop = 4;
         
        count = 0;
        game_sounds(GameDat,TURN);
        while(count++ <loop && status != 'L'){
       	draw_board(board,GameBitmaps,token,GameDat);
       	status = Player(board,walls,token,count,GameDat,sound_clip);
	  	if(status == 'Q')
	      return;
	  	draw_board(board,GameBitmaps,token,GameDat);
		contact = check_collision(token);
		if(contact == 'S'&& Treasure_Captured == TRUE)
			token[TREASURE].piece = 'P';
		draw_board(board,GameBitmaps,token,GameDat);
		if(contact == 'V'){
          Win_Lose('V',GameDat,WINNER);
		  return;
          }
		if(contact == 'D'){
          Win_Lose('D',GameDat,DEFEAT);
		  return;
          }
	    if(contact == 'S'&& Treasure_Captured == FALSE){
	  	  Win_Lose('S',GameDat,TREASURE_S);
	  	  loop = count;
	  	  Treasure_Captured = TRUE;
	  		 }
		contact = check_close(token);
		if((contact == 'C')&& (token[PLAYER].piece !='C')&& Close_Status == FALSE){
 			Close_Status = TRUE;
			Win_Lose('C',GameDat,AWAKE);}
		} // End Player move loop
        status = '*';
		draw_board(board,GameBitmaps,token,GameDat);
  	if(Close_Status == 1){
		token[DRAGON].piece='F';
		Dragon(board,token,GameDat,FLY);
		draw_board(board,GameBitmaps,token,GameDat);
		contact = check_collision(token);
		draw_board(board,GameBitmaps,token,GameDat);
		if(contact == 'D'){
          Win_Lose('D',GameDat,DEFEAT);
		  return;}
	       }//End if for Dragon
	 } //End If
}// End gameplay()

char Player(char board[][15],char walls[][15],bchar token[],int count,DATAFILE *GameDat,int sound_clip){
	//Prompt player to move
    textprintf_ex(screen,(FONT*)GameDat[KingsQ_12].dat, 192, 57, BR_YELLOW, -1, "Venture on Sire");

    if(token[PLAYER].piece == 'C') // If Player has Captured Treasure, both board squares need to change
    	token[TREASURE].piece = 'G';

    clear_keybuf();
    int direction = dir_key();
    int iPlayer_X = token[PLAYER].x;
    int iPlayer_Y = token[PLAYER].y;
    int iOutside = 0;
	if ((direction == 0)&&(iPlayer_X>1)) {
      if(walls[iPlayer_X-1][iPlayer_Y]== '/'){
		board[iPlayer_X-1][iPlayer_Y]= walls[iPlayer_X-1][iPlayer_Y];
	    game_sounds(GameDat,WALL);
		return('L');}
      else
   	   iOutside=1;
       game_sounds(GameDat,STEP);
       token[PLAYER].x-=OFFSET;
    } // End Direction 0 If

	if ((direction == 1)&&(iPlayer_Y>1)) {
	   if(walls[iPlayer_X][iPlayer_Y-1]== '#'){
			board[iPlayer_X][iPlayer_Y-1]=walls[iPlayer_X][iPlayer_Y-1];
			game_sounds(GameDat,WALL);
			return('L');}
       else 
    	   iOutside=1;
    	   game_sounds(GameDat,STEP);
			token[PLAYER].y-=OFFSET;
    } // End Direction 1 If		
	if ((direction == 2)&&(iPlayer_X<14)) {
     	if(walls[iPlayer_X+1][iPlayer_Y]== '/'){
			board[iPlayer_X+1][iPlayer_Y]=walls[iPlayer_X+1][iPlayer_Y];
			game_sounds(GameDat,WALL);
			return('L');}
       else 
    	   iOutside=1;
    	   game_sounds(GameDat,STEP);
    	   token[PLAYER].x+=OFFSET;
    } // End Direction 2 If		
 	if ((direction == 3)&&(iPlayer_Y<14)) {
 		if(walls[iPlayer_X][iPlayer_Y+1]== '#'){
			board[iPlayer_X][iPlayer_Y+1]=walls[iPlayer_X][iPlayer_Y+1];
			game_sounds(GameDat,WALL);
			return('L');}
       else 
    	   iOutside=1;
    	   game_sounds(GameDat,STEP);
			token[PLAYER].y+=OFFSET;
    } // End Direction 3 If		
     	if (direction == 4)
	     	return('Q');

 clear_keybuf();
 rest(150);
 board[token[PLAYER].x][token[PLAYER].y] = token[PLAYER].piece;
 if(iOutside == 0){
	game_sounds(GameDat,WALL);
	return('L');}
 return('P');

} // End Player()


void Dragon(char board[][15],bchar token[],DATAFILE *GameDat,int sound_clip){

	int sign_x= 0;
	int sign_y=0;
    int answer_x=0;
    int answer_y=0;

    textprintf_ex(screen, (FONT*)GameDat[KingsQ_12].dat, 192, 57, ORANGE, -1, "Beware the Dragon");
    game_sounds(GameDat,sound_clip);

    answer_x = token[PLAYER].x - token[DRAGON].x;
     if(answer_x < 0){
    	answer_x = 0-answer_x;
    	sign_x = -1;}
     else sign_x = 1;
    answer_y = token[PLAYER].y - token[DRAGON].y;
     if(answer_y < 0){
     	answer_y = 0-answer_y;
  	    sign_y = -1;}
     else sign_y = 1;
   if(answer_x >= answer_y)
	   token[DRAGON].x = token[DRAGON].x +(OFFSET*sign_x);
   else token[DRAGON].y = token[DRAGON].y +(OFFSET*sign_y);
//} // End else (Player piece = C)
board[token[DRAGON].x][token[DRAGON].y] = token[DRAGON].piece;


} // End DRAGON()

char check_close(bchar token[]){


	for(int count_x = -2;count_x <=2;count_x++){
		for(int count_y= -2;count_y<=2;count_y++){
		  if(((token[PLAYER].x + (count_x*OFFSET)) == token[TREASURE].x )&&((token[PLAYER].y +(count_y*OFFSET)) == token[TREASURE].y))
		  return('C');}}

	return('J');

} //End check_close()
char check_collision(bchar token[]){

    if ((token[PLAYER].x == token[TREASURE].x) &&(token[PLAYER].y == token[TREASURE].y)&& (token[PLAYER].piece !='C')){
    	token[TREASURE].piece = 'T';
    	token[PLAYER].piece = 'C';
	    return('S');}
	if ((token[PLAYER].x == token[ESCAPE].x) &&(token[PLAYER].y == token[ESCAPE].y)&& token[PLAYER].piece== 'C'){
		token[PLAYER].piece = 'V';
		return('V');}
	if ((token[PLAYER].x == token[DRAGON].x) &&(token[PLAYER].y == token[DRAGON].y)){
		token[PLAYER].piece = 'D';
		token[DRAGON].piece = 'D';
		if(token[TREASURE].piece == '.')
			token[TREASURE].piece = 'T';
		return('D');}

    return (' ');

} //End check_collision()

void Win_Lose(char contact,DATAFILE *GameDat,int sound_clip){

	if(contact == 'S'){
    textprintf_ex(screen, (FONT*)GameDat[KingsQ_12].dat, 192, 57, BR_GREEN, -1, "TREASURE FOUND NOW TO ESCAPE");
    game_sounds(GameDat,sound_clip);
    textprintf_ex(screen, (FONT*)GameDat[KingsQ_12].dat, 192, 73, BR_RED, -1, "Hit any key to continue...");
    readkey();
	clear_keybuf();}

	if(contact == 'V'){
    textprintf_ex(screen, (FONT*)GameDat[KingsQ_12].dat, 192, 57, BR_GREEN, -1, "VICTORY IS YOUR'S SIRE");
    game_sounds(GameDat,sound_clip);
    textprintf_ex(screen, (FONT*)GameDat[KingsQ_12].dat, 192, 73, BR_RED, -1, "Hit any key to continue...");
    readkey();
	clear_keybuf();}

	if(contact == 'D'){
    textprintf_ex(screen, (FONT*)GameDat[KingsQ_12].dat, 192, 57, BR_MAGENTA, -1, "Death of a Noble Warrior");
    game_sounds(GameDat,sound_clip);
    textprintf_ex(screen, (FONT*)GameDat[KingsQ_12].dat, 192, 73, BR_RED, -1, "Hit any key to continue...");
    readkey();
	clear_keybuf();}

	if(contact == 'C'){
    textprintf_ex(screen, (FONT*)GameDat[KingsQ_12].dat, 192, 57, BR_MAGENTA, -1, "Glory is close but ...");
    textprintf_ex(screen, (FONT*)GameDat[KingsQ_12].dat, 192, 73, BR_MAGENTA, -1, "You have awaken the Dragon!");
    game_sounds(GameDat,sound_clip);
    rest(1800);
	}

} //End Win_Lose()
